/***************************************************************************

         __________________ _ 
|\     /|\__   __/\__   __/( \      
| )   ( |   ) (      ) (   | (      
| |   | |   | |      | |   | |      
| |   | |   | |      | |   | |      
| |   | |   | |      | |   | |      
| (___) |   | |   ___) (___| (____/\
(_______)   )_(   \_______/(_______/
                                    

*************  SOME FUNCTIONS  TO CONVERT AND MANIPULATE DATA  *************
****************************************************************************/


//void Integer2Bytes(unsigned char** ArrayPtr, unsigned int Integ)
//{
//	unsigned char* Array = *ArrayPtr;
//	unsigned int Integer = Integ;
//
//	Array++;
//	*Array = (unsigned char)(Integer & 0x00FF);	// LSB in second position 
//	Array--;
//	Integer = Integer>>8;
//	*Array = (unsigned char)Integer;		// MSB in first position of the array
//}


/*
********************************************************************************
*              CONVERT CHAR INTO HEX
*
* Description : This function converts a character('0'-'F') to a HEX
* Arguments   : c -  is a character('0'-'F') to convert to HEX
* Returns     : HEX
* Note        :
********************************************************************************
*/

char C2D(unsigned char c)
{
  if (c >= '0' && c <= '9')
    return c - '0';
  if (c >= 'a' && c <= 'f')
    return 10 + c -'a';
  if (c >= 'A' && c <= 'F')
    return 10 + c -'A';
  
  return (char)c;
}

/*
********************************************************************************
*              CONVERT STRING INTO INTEGER
*
* Description : This function converts a string to a integer number.
* Arguments   : str  -  is a pointer to convert
*               base - is a base value (must be in the range 2 - 16)
* Returns     : a integer number
* Note        :
********************************************************************************
*/

unsigned int ATOI(char* str,unsigned int base)
{
  unsigned int num = 0;
  while (*str !=0){
    num = num * base + C2D(*str++);
  }
  return num;
}

/*
********************************************************************************
*              CONVERT STRING INTO HEX OR DECIMAL
*
* Description : This function converts a string to a HEX number or a decimal number.
* Arguments   : str  - is a pointer to string to be converted
*               base - is a base value (must be in the range 2 - 16)
*               ret  - is a integer pointer to return
* Returns     : success - 1, fail - 0
* Note        :
********************************************************************************
*/

unsigned char ValidATOI(char* str, int base, unsigned int* ret)
{
  int c;
  char* tstr = str;
  if(str == 0 || *str == '\0') return 0;
  while(*tstr != '\0')
  {
    c = C2D(*tstr);
    if( c >= 0 && c < base){
      tstr++;
    }else{
      return 0;
    }
  }
  *ret = ATOI(str,base);
  return 1;
}

//
/*
Description   :  Verify dotted notation IP address string
Argument      :  src - pointer to IP address string
Return Value  :  success - 1, fail - 0
Note          :  
*/


unsigned int VerifyIPAddress(char src[])
{
  int i, j;
  unsigned int tnum;
  String str_cpy;
  String temp_str;
  char buf[5];
  char *tmp_buf;
  char *end_buf;
  char IP[16];
  
  tmp_buf = src;
  for(int j=0;;){
    if((*tmp_buf < 0x30) || (*tmp_buf > 0x39))
      tmp_buf++;
    else
      break;
  }
  end_buf = strstr(tmp_buf, "\r\n");
  if(end_buf != NULL){
    strncpy(IP, tmp_buf, (end_buf - tmp_buf));
    str_cpy = String(IP);  
  }else
    return(0);
  for(i = 0; i < 4; i++)
  {
    j = str_cpy.indexOf(".");
    if(j == -1 && i != 3){
      return(0);
    }
    if(i != 3){
      temp_str = str_cpy.substring(0, j);
      str_cpy = str_cpy.substring(j+1);                // don't want the .
    }else{
      temp_str = str_cpy;
    }
    temp_str.toCharArray(buf, 5);          // buf have the XXXX number which could be hex or decimal
    
    if(buf[0] == '0' && buf[1] == 'x')
    {
      if(!ValidATOI(buf+2,0x10,&tnum)) return(0);            // verify a string of this form "0xC0.0xA8.0x01.0x7F"
    }else{
      if(!ValidATOI(buf,10,&tnum)) return(0);                // verify a string of this form "192.168.1.127"
    }
    if(tnum < 0 || tnum > 255) return(0);
  }
  return(1);	
}
/*****************************************************************************
 * EOF
 *****************************************************************************/

