/****************************************************************************** 
 _______           _______ _________ _______  _______ 
(  ____ \|\     /|(  ____ \\__   __/(  ____ \(       )
| (    \/( \   / )| (    \/   ) (   | (    \/| () () |
| (_____  \ (_) / | (_____    | |   | (__    | || || |
(_____  )  \   /  (_____  )   | |   |  __)   | |(_)| |
      ) |   ) (         ) |   | |   | (      | |   | |
/\____) |   | |   /\____) |   | |   | (____/\| )   ( |
\_______)   \_/   \_______)   )_(   (_______/|/     \|
                                                      
 ______   _______  _______  _______ 
(  __  \ (  ____ \(  ____ \(  ____ \
| (  \  )| (    \/| (    \/| (    \/
| |   ) || (__    | (__    | (_____ 
| |   | ||  __)   |  __)   (_____  )
| |   ) || (      | (            ) |
| (__/  )| (____/\| )      /\____) |
(______/ (_______/|/       \_______)
                                    
******************************************************************************/


//  System definitions

#define SYNC_RTC 1*60*60      // Every hour sync with RTCC.

#define __bttn_sim__          // simulate a button press using the serial port. buttom variable <buttonState> will be set by Serial Port reception command. 
#define __format_output__     // identify command generated by Arduino and Responses from Modem prefixing a> (arduino) and m> (modem) 
//#define __no_format__
#define __sram_wr_debug__     // enable debug mode for commands that handle the SRAM 
//#define __dbg_pachube_qry__   // print the data that will be send to pachube.   
#define __debug_cmd__         // 
//#define __debug_cmd__L2
#define __debug_sms__
#define __debug__
//#define __SIM340__          // Only SIM340 or SIM900 at a given time. 
#define __SIM900__            // Enable the SIM900 functions
#define __log2file__          // Enable log modem responses to file.
//#define __GPRS_compile__    // Enable to compile GPRS code.
#define __XBeeNetwork__       // Enable the XBee sensor network compilation.
#define __SD_CARD__           // Enable the SD card.
#define __RTCC__              // Enable the external RTCC
#define __Web_Server__        // Enable the Web Server (remember it need the SD library to work)
//#define __Watch_Dog__       // Enable the Watch Dog.


#if defined __format_output__
#if defined __no_format__
#error  "Response need to be formated or not formatted, not both at the same time"
#endif
#endif

#if defined __SIM900__
#if defined __SIM340__
#error  "Both SIMCOM modules can't be defined at the same time"
#endif
#endif

// pachube definitions
#define COSM_DOMAIN  "api.cosm.com"
#define IPADDR "173.203.98.29"              // pachube.com
#define PORT 80                             // HTTP
#define API_KEY "REPLACE THIS WITH YOUR API KEY"       // your Cosm API key
#define SHARE_FEED_ID 99999   // PLACE HERE YOUR FEED ID NUMBER.
#define SHARE_FEED_ID_STRING "FEED ID STRING"
#define CONTROL_FEED_ID  99999  // FETURE NOT YET SUPPORTED
// feeds aliases
#define SW1 0        // datastream = 0
#define IOT  300     // Internet Of Things buffer

#define EMAILTIMEOUT 60        

// I/O definitions
#define MODEM_PWR  73    // pin 73 or RA5 on MAX32 board used for modem power up/down

// Some state and system variables (SRAM positions)
#define eeprom_phone_entry_num         0x00        // number of entries (phone numbers saved)
#define eeprom_phone_entry_last        0x01        // Eeprom address of last position available to write a new entry.
#define eeprom_mail_entry_num          0x02        // number of entries (phone numbers saved)
#define eeprom_mail_entry_last_msb     0x03        // Eeprom address of last position available to write a new entry.
#define eeprom_mail_entry_last_lsb     0x04        // Eeprom address of last position available to write a new entry.

// Eeprom Memory MAP

//  ______________________________________________
// |   ADDR  RANGE    |            USE            |
// |__________________|___________________________|
// | 0x0000 - 0x00FF  |     PHONE BOOK            |
// | 0x0100 - 0x0170  |     EMAIL ADDRESS BOOK    |
// | 0x0171 - 0x01FF  |     SITE NAME             |
// |__________________|___________________________|


// ChipSolar Board Input definitions
#define LT4411_STAT  72
#define LTC3652_CHRG  71
#define LTC3652_FAULT  70
//#define LTC3112_IMON A8

// SensorNetwork Definition
// These definitions should be entered during operation and save to Eeprom
#define Coordinator_msb        0x13A200
#define Coordinator_lsb        0x405CA396            // XBee Sensor address
#define XBeeSensor_msb         0x13A200
#define XBeeSensor_lsb         0x403C8806            // XBee Sensor address
#define XBeeWallRouter_msb     0x13A200
#define XBeeWallRouter_lsb     0x403C99E5            // XBee Wall Router address
#define XBeeRMA_msb            0x13A200
#define XBeeRMA_lsb            0x4030C173            // XBee with RAM antenna (router)
#define XBeeEnd_msb            0x13A200
#define XBeeEnd_lsb            0x405CA391            // XBee End Device
#define XBeeEnd2_msb           0x13A200
#define XBeeEnd2_lsb           0x40481DBB            // XBee End Device

#define Coordinator   0x00
#define Router   0x01
#define EndDevice   0x02
#define __debug_xbee__


#define MailBufSize  500
#define RxBufSize    1000



