
#include "Xbee_defs.h"
#include <XBee.h>
#include <Sensors.h>



XBee xbee = XBee();
XBeeResponse response = XBeeResponse();
// create reusable response objects for responses we expect to handle 
ZBRxResponse rx = ZBRxResponse();
ModemStatusResponse msr = ModemStatusResponse();

ZBRxIoSampleResponse ioSample = ZBRxIoSampleResponse();

XBeeAddress64 device_addr = XBeeAddress64();

String ioSampleAdd, rxResponseAdd, Str2Cmp;
String DIO_conf_values[] = { 
                              "1 - Commissioning button enabled\n"        // DIO0 options
                              "2 - Analog input, single ended\n"
                              "3 - Digital input\n"
                              "4 - Digital output, low\n"
                              "5 - Digital output, high\n",
                              
                              " ", 
                              " "
                            };

float tempC, light;
float mVanalog;

// Set DIO4 to Digital HIGH
uint8_t d4Cmd[] = { 'D', '4' };
uint8_t d4ValueHigh[] = { 0x5 };
uint8_t d4ValueLow[] = { 0x4 };

// Broadcast Address
uint16_t unknowntAddr = 0xFFFE;
// Set DIO4 to Digital HIGH
uint8_t discoverCmd[] = { 'N', 'D' };            // Node Discovery Command (recommended only if the network is not large)
// Network Discovery Command
RemoteAtCommandRequest discoveryAtRequest = RemoteAtCommandRequest(unknowntAddr, discoverCmd);

uint8_t temp_type;
uint16_t temp_parent;
int next = 0;

// SH + SL of your remote radio
XBeeAddress64 remoteAddress = XBeeAddress64(0x0013A200, 0x4030C173);
XBeeAddress64 Addr2Cmp = XBeeAddress64();
// Create a remote AT request 
RemoteAtCommandRequest RemAtRequest = RemoteAtCommandRequest(remoteAddress, d4Cmd, d4ValueLow, sizeof(d4ValueLow));

// Create a Remote AT response object
RemoteAtCommandResponse remoteAtResponse = RemoteAtCommandResponse();

// Our Sensor Class Instances

UserSensorsList  UsrDefSensors;
XBeeDeviceBase*  devices[MAX_NUM_XBEE_SENSORS];
int dev;

//int dio_cmd_gen(XBeeAddress64 RemAddr, uint8_t* dioCmd, uint8_t* dioVal){
//  String tempCmd;
//  char temp;
//  int value2verify;
//  char cvalue2verify[3];
//  
//  Serial.println("Enter DIO number to configure:");
//  delay(200);
//  while(Serial.available()){
//    temp = Serial.read();
//    tempCmd += temp;
//  }
//  tempCmd.toCharArray(cvalue2verify, tempCmd.length()+1); 
//  value2verify = atoi(cvalue2verify);
//  if(value2verify < 0 || value2verify > 12 || value2verify == 9){
//    Serial.println("Not a valid DIO to configure");
//    Serial.flush();
//    return(0);
//  }else{
//     
//    
//  }
//  
//}



void setup()
{
  xbee.begin(9600);
  // Uses Serial Port 2 to allow monitoring output on Serial Port 0.
  Serial2.begin(9600);
  xbee.setSerial(Serial2);
  // start soft serial
  Serial.begin(9600);
  Serial.println("XBee demo");
  // Startup delay to wait for XBee radio to initialize.
  // you may need to increase this value if you are not getting a response.
  delay(5000);
  Serial.println("a>Send something to start");
  Serial.flush();
  while(!Serial.available());
  delay(200);                          // allow a bunch of characters to be discarded, just for the blow out your code people out there!
  Serial.flush();
  // wait for serial monitor to send anything... just for debug
 
   
  UsrDefSensors.add2list(XBeeAddress64(XBeeSensor_msb, XBeeSensor_lsb), EndDevice, 0xFFFE);
  UsrDefSensors.add2list(XBeeAddress64(XBeeWallRouter_msb, XBeeWallRouter_lsb), Router, 0xFFFE);
  UsrDefSensors.add2list(XBeeAddress64(XBeeRMA_msb, XBeeRMA_lsb), Router, 0xFFFE);
//  Serial.println("print the user sensor list");  
//  UsrDefSensors.printlist();
  Serial.println("a>Send a Broadcast Node Discovery AT command");
  xbee.send(discoveryAtRequest);

}

int check_if_registered(XBeeAddress64 Addr2Cmp){
  for(int i=0; i < next; i++){
    if(Addr2Cmp.getMsb () == devices[i]->addr.getMsb () && Addr2Cmp.getLsb () == devices[i]->addr.getLsb ())
      return(devices[i]->type);
  }
  return(-1);
}

void loop()
{
  
  xbee.readPacket();
  
  if (xbee.getResponse().isAvailable()) {
    // got something
    
    if (xbee.getResponse().getApiId() == ZB_IO_NODE_IDENTIFIER_RESPONSE) {
      // got a zb rx packet
      // now fill our zb rx class
      xbee.getResponse().getZBRxResponse(rx);      
      device_addr = rx.getRemoteAddress64 ();

      dev = check_if_registered(device_addr);
   //   Serial.print("search address result is ");
      Serial.println(dev);      
      if(dev >= 0){
        #if defined __debug_xbee__
        if(dev == Router){
          Serial.println("Router Joined!");  
        }else if(dev == EndDevice){
          Serial.println("XBee Sensor Joined!");  
        }
        #endif
        // do nothing...
      }else{
        // should register joined device  
        temp_type = rx.getData(rx.getDataOffset () + 4);
        temp_parent = rx.getData(rx.getDataOffset () + 1) << 8 | rx.getData(rx.getDataOffset () + 2);       
        devices[next] = new XBeeDeviceBase(device_addr, temp_parent, temp_type);
        Serial.print("Device type is: ");
        Serial.println(devices[next]->NodeType());
        devices[next]->CreateSensor(&UsrDefSensors);         
        Serial.println("Create Sensor Succedd!");
        next++;        
      }     
      // just some debugging
      #if defined __debug_xbee__
      Serial.print("device 64 address is ");
      Serial.print(device_addr.getMsb(), HEX);
      Serial.println(device_addr.getLsb(), HEX);
      if (rx.getDataLength () > 0){
        Serial.print("getting length = ");  
        Serial.println(rx.getDataOffset (), HEX);
      } 
      Serial.println("RX DATA:");
      for(int i=rx.getDataOffset (); i<rx.getDataLength(); i++){
        Serial.print(rx.getData(i), HEX);
        Serial.print(" ");  
      }
      Serial.print("\n"); 
      #endif
    }else if (xbee.getResponse().getApiId() == ZB_IO_SAMPLE_RESPONSE){
     
      xbee.getResponse().getZBRxIoSampleResponse(ioSample); 
      device_addr = ioSample.getRemoteAddress64();

      int j = 1;
      int i = 0;
      while(devices[i] != NULL){
        if(device_addr.getMsb () == devices[i]->addr.getMsb () && device_addr.getLsb () == devices[i]->addr.getLsb ()){
          devices[i]->ShowSample(ioSample);
          j = 0;
          break;
        }
        i++;
      }
      if(j){            // a sample arrive and the device is not added to the know list of devices, in that case... 
        Serial.println("a>Send a Broadcast Node Discovery AT command");          // send a discovery command.
        xbee.send(discoveryAtRequest);          
      }
      
      #if defined __debug_xbee__
      Serial.print("Received I/O Sample from: ");  
      Serial.print(device_addr.getMsb(), HEX);
      Serial.println(device_addr.getLsb(), HEX);
      
      // debugging purpose

      if (ioSample.containsAnalog()) {
        Serial.print("Sample contains analog data, mask: ");
        Serial.println(ioSample.getAnalogMask(), BIN);
      }

      if (ioSample.containsDigital()) {
        Serial.print("Sample contains digtal data, mask MSB: ");
        Serial.println(ioSample.getDigitalMaskMsb(), BIN);
        Serial.print("mask LSB: ");
        Serial.println(ioSample.getDigitalMaskLsb(), BIN);
      }      
      
      // read analog inputs
      for (int i = 0; i <= 4; i++) {
        if (ioSample.isAnalogEnabled(i)) {
          Serial.print("Analog (AI");
          Serial.print(i, DEC);
          Serial.print(") is ");
          Serial.println(ioSample.getAnalog(i), DEC);
        }
      }

      // check digital inputs
      for (int i = 0; i <= 12; i++) {
        if (ioSample.isDigitalEnabled(i)) {
          Serial.print("Digital (DI");
          Serial.print(i, DEC);
          Serial.print(") is ");
          Serial.println(ioSample.isDigitalOn(i), DEC);
        }
      }
      #endif      
    }else if (xbee.getResponse().getApiId() == REMOTE_AT_COMMAND_RESPONSE) {    // should be an AT command response
      xbee.getResponse().getRemoteAtCommandResponse(remoteAtResponse);

      if (remoteAtResponse.isOk()) {
        Serial.print("Command [");
        Serial.print(remoteAtResponse.getCommand()[0]);
        Serial.print(remoteAtResponse.getCommand()[1]);
        Serial.println("] was successful!");
        
        // if it's a response of Node Discovery Command then
        if(remoteAtResponse.getCommand()[0] == 'N' && remoteAtResponse.getCommand()[1] == 'D'){
          device_addr = remoteAtResponse.getRemoteAddress64();
          dev = check_if_registered(device_addr);     
          if(dev >= 0){
            if(dev == Router){
              Serial.println("A Router Device already added with address: ");  
            }else if(dev == EndDevice){
              Serial.println("An End Device already added with address: ");  
            }
            Serial.print("0x");
            Serial.print(device_addr.getMsb(), HEX);
            Serial.print(" 0x");
            Serial.println(device_addr.getLsb(), HEX);            
          }else{
            uint8_t *AtCmdResponse;
            AtCmdResponse = remoteAtResponse.getValue ();
            AtCmdResponse += 10;                                                  // Point to first byte of NI String.
            while(*AtCmdResponse != 0x00)
              AtCmdResponse++;
            AtCmdResponse++;                                                      // Point to Parent 16 Bit Address first byte.
            temp_parent = *AtCmdResponse++;
            temp_parent <<= 8;
            temp_parent |= *AtCmdResponse++;
            temp_type = *AtCmdResponse;
            
            devices[next] = new XBeeDeviceBase(device_addr, temp_parent, temp_type);
            Serial.print("New ");
            Serial.println(devices[next]->NodeType());     
            Serial.print(" added to the Network list with address: 0x");  
            Serial.print(devices[next]->addr.getMsb(), HEX);
            Serial.print(" 0x");
            Serial.println(devices[next]->addr.getLsb(), HEX);
            devices[next]->CreateSensor(&UsrDefSensors);
            next++;
          }
        }

      } else {
        Serial.print("Command returned error code: ");
        Serial.println(remoteAtResponse.getStatus(), HEX);
      }
    }
  }else if (xbee.getResponse().isError()) {
    Serial.print("Error reading packet.  Error code: ");  
    Serial.println(xbee.getResponse().getErrorCode());
  }
}
